Option Strict Off
Option Explicit On
Friend Class Form1
	Inherits System.Windows.Forms.Form
	'Set this to "1" if making an exe or "0" if debugging
	'(so that the full paths are included in the declare statements)
#Const EXE_BUILD = 1
	
#If EXE_BUILD Then
	Private Declare Function ECIO_GetDLLVersion Lib "ECIO_api.dll" () As Integer
    Private Declare Function ECIO_Open Lib "ECIO_api.dll" (ByVal index As Integer, ByRef pVID_PID As Byte) As Integer
	Private Declare Function ECIO_Close Lib "ECIO_api.dll" () As Integer
    Private Declare Function ECIO_Transmit Lib "ECIO_api.dll" (ByRef pDataOut As Byte, ByVal dwLenOut As Integer, ByRef pActualLenOut As Integer, ByRef pDataIn As Byte, ByVal dwExpectedLenIn As Integer, ByRef pActualLenIn As Integer, ByVal dwTimeout As Integer) As Integer
    Private Declare Function ECIO_GetDeviceCount Lib "ECIO_api.dll" (ByRef pVID_PID As Byte) As Integer
#Else
	Private Declare Function ECIO_GetDLLVersion Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" () As Long
	Private Declare Function ECIO_Open Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByVal index As Long, ByRef pVID_PID As Any) As Long
	Private Declare Function ECIO_Close Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" () As Long
	Private Declare Function ECIO_Transmit Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByRef pDataOut As Any, ByVal dwLenOut As Long, ByRef pActualLenOut As Long, ByRef pDataIn As Any, ByVal dwExpectedLenIn As Long, ByRef pActualLenIn As Long, ByVal dwTimeout As Long) As Long
	Private Declare Function ECIO_GetDeviceCount Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByRef pVID_PID As Any) As Long
#End If
	
	Private position As Byte
	Private old_position As Byte
	Private sID(20) As Byte
	Private steps(7) As Byte
	
	Private Sub ACW_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles ACW.Click
		
		If (position > 0) Then
			position = position - 1
		Else
			position = 47
		End If
		
		Step_Renamed.Text = CStr(position)
		
	End Sub
	
	Private Sub CW_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CW.Click
		
		If (position < 47) Then
			position = position + 1
		Else
			position = 0
		End If
		
		Step_Renamed.Text = CStr(position)
		
	End Sub
	
	Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		'Set the identifier
		sID(0) = Asc("v")
		sID(1) = Asc("i")
		sID(2) = Asc("d")
		sID(3) = Asc("_")
		sID(4) = Asc("1")
		sID(5) = Asc("2")
		sID(6) = Asc("b")
		sID(7) = Asc("f")
		sID(8) = Asc("&")
		sID(9) = Asc("p")
		sID(10) = Asc("i")
		sID(11) = Asc("d")
		sID(12) = Asc("_")
		sID(13) = Asc("0")
		sID(14) = Asc("2")
		sID(15) = Asc("1")
		sID(16) = Asc("0")
		sID(17) = 0
		
		'Set the step positions
		steps(0) = 9
		steps(1) = 1
		steps(2) = 5
		steps(3) = 4
		steps(4) = 6
		steps(5) = 2
		steps(6) = 10
		steps(7) = 8
		
		position = 0
		old_position = 1
		
		Dim lRetVal As Integer
		lRetVal = ECIO_Open(0, sID(0))
		
	End Sub
	
	Private Sub Form1_FormClosing(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
		Dim Cancel As Boolean = eventArgs.Cancel
		Dim UnloadMode As System.Windows.Forms.CloseReason = eventArgs.CloseReason
		'Make sure the connection is closed
		ECIO_Close()
		eventArgs.Cancel = Cancel
	End Sub
	
	Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick
		
		Dim step_output As Byte
		Dim op1 As Byte
		Dim op2 As Byte
		Dim op3 As Byte
		Dim op4 As Byte
		
		If position = old_position Then
			
			'No movement so disable outputs
			op1 = 0
			op2 = 0
			op3 = 0
			op4 = 0
			
		Else
			
			'Collect the coil states
			step_output = position Mod 8
			
			'Assign the coil states to the outputs
			If (steps(step_output) And 8) > 0 Then
				op1 = 1
			Else
				op1 = 0
			End If
			
			If (steps(step_output) And 4) > 0 Then
				op2 = 1
			Else
				op2 = 0
			End If
			
			If (steps(step_output) And 2) > 0 Then
				op3 = 1
			Else
				op3 = 0
			End If
			
			If (steps(step_output) And 1) > 0 Then
				op4 = 1
			Else
				op4 = 0
			End If
			
			COILA.CheckState = op1
			COILB.CheckState = op2
			COILC.CheckState = op3
			COILD.CheckState = op4
			
		End If
		
		Dim lRetVal As Integer
		Dim bDataOut(2) As Byte
		Dim bDataIn(2) As Byte
		Dim nTxDataCnt As Integer
		Dim nRxDataCnt As Integer
		
		bDataOut(0) = 7 'Digital Output Transistor Command
		bDataOut(1) = 1 'Output To channel A
		bDataOut(2) = op1 'Value of coil state
		lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
		
		bDataOut(0) = 7 'Digital Output Transistor Command
		bDataOut(1) = 2 'Output To channel B
		bDataOut(2) = op2 'Value of coil state
		lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
		
		bDataOut(0) = 7 'Digital Output Transistor Command
		bDataOut(1) = 3 'Output To channel C
		bDataOut(2) = op3 'Value of coil state
		lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
		
		bDataOut(0) = 7 'Digital Output Transistor Command
		bDataOut(1) = 4 'Output To channel D
		bDataOut(2) = op4 'Value of coil state
		lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
		
		old_position = position
		
	End Sub
End Class